/* item.c generated by valac 0.14.0, the Vala compiler
 * generated from item.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdio.h>


#define GPASTE_DAEMON_TYPE_ITEM_KIND (gpaste_daemon_item_kind_get_type ())

#define GPASTE_DAEMON_TYPE_ITEM (gpaste_daemon_item_get_type ())
#define GPASTE_DAEMON_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_ITEM, GPasteDaemonItem))
#define GPASTE_DAEMON_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_ITEM, GPasteDaemonItemClass))
#define GPASTE_DAEMON_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_ITEM))
#define GPASTE_DAEMON_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_ITEM))
#define GPASTE_DAEMON_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_ITEM, GPasteDaemonItemClass))

typedef struct _GPasteDaemonItem GPasteDaemonItem;
typedef struct _GPasteDaemonItemClass GPasteDaemonItemClass;
typedef struct _GPasteDaemonItemPrivate GPasteDaemonItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GPASTE_DAEMON_TYPE_TEXT_ITEM (gpaste_daemon_text_item_get_type ())
#define GPASTE_DAEMON_TEXT_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_TEXT_ITEM, GPasteDaemonTextItem))
#define GPASTE_DAEMON_TEXT_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_TEXT_ITEM, GPasteDaemonTextItemClass))
#define GPASTE_DAEMON_IS_TEXT_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_TEXT_ITEM))
#define GPASTE_DAEMON_IS_TEXT_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_TEXT_ITEM))
#define GPASTE_DAEMON_TEXT_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_TEXT_ITEM, GPasteDaemonTextItemClass))

typedef struct _GPasteDaemonTextItem GPasteDaemonTextItem;
typedef struct _GPasteDaemonTextItemClass GPasteDaemonTextItemClass;
typedef struct _GPasteDaemonTextItemPrivate GPasteDaemonTextItemPrivate;

#define GPASTE_DAEMON_TYPE_IMAGE_ITEM (gpaste_daemon_image_item_get_type ())
#define GPASTE_DAEMON_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_IMAGE_ITEM, GPasteDaemonImageItem))
#define GPASTE_DAEMON_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_IMAGE_ITEM, GPasteDaemonImageItemClass))
#define GPASTE_DAEMON_IS_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_IMAGE_ITEM))
#define GPASTE_DAEMON_IS_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_IMAGE_ITEM))
#define GPASTE_DAEMON_IMAGE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_IMAGE_ITEM, GPasteDaemonImageItemClass))

typedef struct _GPasteDaemonImageItem GPasteDaemonImageItem;
typedef struct _GPasteDaemonImageItemClass GPasteDaemonImageItemClass;
typedef struct _GPasteDaemonImageItemPrivate GPasteDaemonImageItemPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GPASTE_DAEMON_ITEM_KIND_TEXT,
	GPASTE_DAEMON_ITEM_KIND_IMAGE
} GPasteDaemonItemKind;

struct _GPasteDaemonItem {
	GObject parent_instance;
	GPasteDaemonItemPrivate * priv;
};

struct _GPasteDaemonItemClass {
	GObjectClass parent_class;
	gboolean (*has_value) (GPasteDaemonItem* self);
	gchar* (*get_display_str) (GPasteDaemonItem* self);
	gchar* (*get_kind) (GPasteDaemonItem* self);
	gboolean (*equals) (GPasteDaemonItem* self, GPasteDaemonItem* i);
};

struct _GPasteDaemonItemPrivate {
	gchar* _str;
};

struct _GPasteDaemonTextItem {
	GPasteDaemonItem parent_instance;
	GPasteDaemonTextItemPrivate * priv;
};

struct _GPasteDaemonTextItemClass {
	GPasteDaemonItemClass parent_class;
};

struct _GPasteDaemonImageItem {
	GPasteDaemonItem parent_instance;
	GPasteDaemonImageItemPrivate * priv;
};

struct _GPasteDaemonImageItemClass {
	GPasteDaemonItemClass parent_class;
};

struct _GPasteDaemonImageItemPrivate {
	gchar* display_str;
	GDateTime* _date;
	gchar* _checksum;
	GdkPixbuf* _img;
};


static gpointer gpaste_daemon_item_parent_class = NULL;
static gpointer gpaste_daemon_text_item_parent_class = NULL;
static gpointer gpaste_daemon_image_item_parent_class = NULL;

GType gpaste_daemon_item_kind_get_type (void) G_GNUC_CONST;
GType gpaste_daemon_item_get_type (void) G_GNUC_CONST;
#define GPASTE_DAEMON_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_DAEMON_TYPE_ITEM, GPasteDaemonItemPrivate))
enum  {
	GPASTE_DAEMON_ITEM_DUMMY_PROPERTY,
	GPASTE_DAEMON_ITEM_STR
};
gboolean gpaste_daemon_item_has_value (GPasteDaemonItem* self);
static gboolean gpaste_daemon_item_real_has_value (GPasteDaemonItem* self);
gchar* gpaste_daemon_item_get_display_str (GPasteDaemonItem* self);
static gchar* gpaste_daemon_item_real_get_display_str (GPasteDaemonItem* self);
gchar* gpaste_daemon_item_get_kind (GPasteDaemonItem* self);
static gchar* gpaste_daemon_item_real_get_kind (GPasteDaemonItem* self);
gboolean gpaste_daemon_item_equals (GPasteDaemonItem* self, GPasteDaemonItem* i);
static gboolean gpaste_daemon_item_real_equals (GPasteDaemonItem* self, GPasteDaemonItem* i);
GPasteDaemonItem* gpaste_daemon_item_construct (GType object_type);
const gchar* gpaste_daemon_item_get_str (GPasteDaemonItem* self);
void gpaste_daemon_item_set_str (GPasteDaemonItem* self, const gchar* value);
static void gpaste_daemon_item_finalize (GObject* obj);
static void _vala_gpaste_daemon_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_daemon_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType gpaste_daemon_text_item_get_type (void) G_GNUC_CONST;
enum  {
	GPASTE_DAEMON_TEXT_ITEM_DUMMY_PROPERTY
};
GPasteDaemonTextItem* gpaste_daemon_text_item_new (const gchar* str);
GPasteDaemonTextItem* gpaste_daemon_text_item_construct (GType object_type, const gchar* str);
static gchar* gpaste_daemon_text_item_real_get_display_str (GPasteDaemonItem* base);
static gboolean gpaste_daemon_text_item_real_has_value (GPasteDaemonItem* base);
static gchar* gpaste_daemon_text_item_real_get_kind (GPasteDaemonItem* base);
static gboolean gpaste_daemon_text_item_real_equals (GPasteDaemonItem* base, GPasteDaemonItem* i);
GType gpaste_daemon_image_item_get_type (void) G_GNUC_CONST;
#define GPASTE_DAEMON_IMAGE_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_DAEMON_TYPE_IMAGE_ITEM, GPasteDaemonImageItemPrivate))
enum  {
	GPASTE_DAEMON_IMAGE_ITEM_DUMMY_PROPERTY,
	GPASTE_DAEMON_IMAGE_ITEM_DATE,
	GPASTE_DAEMON_IMAGE_ITEM_CHECKSUM,
	GPASTE_DAEMON_IMAGE_ITEM_IMG
};
GPasteDaemonImageItem* gpaste_daemon_image_item_new (GdkPixbuf* img);
GPasteDaemonImageItem* gpaste_daemon_image_item_construct (GType object_type, GdkPixbuf* img);
static void gpaste_daemon_image_item_set_date (GPasteDaemonImageItem* self, GDateTime* value);
static void gpaste_daemon_image_item_set_img (GPasteDaemonImageItem* self, GdkPixbuf* value);
static void gpaste_daemon_image_item_set_checksum (GPasteDaemonImageItem* self, const gchar* value);
const gchar* gpaste_daemon_image_item_get_checksum (GPasteDaemonImageItem* self);
GdkPixbuf* gpaste_daemon_image_item_get_img (GPasteDaemonImageItem* self);
GDateTime* gpaste_daemon_image_item_get_date (GPasteDaemonImageItem* self);
GPasteDaemonImageItem* gpaste_daemon_image_item_new_load (const gchar* path, GDateTime* date);
GPasteDaemonImageItem* gpaste_daemon_image_item_construct_load (GType object_type, const gchar* path, GDateTime* date);
static gchar* gpaste_daemon_image_item_real_get_display_str (GPasteDaemonItem* base);
static gboolean gpaste_daemon_image_item_real_has_value (GPasteDaemonItem* base);
static gchar* gpaste_daemon_image_item_real_get_kind (GPasteDaemonItem* base);
static gboolean gpaste_daemon_image_item_real_equals (GPasteDaemonItem* base, GPasteDaemonItem* i);
static void gpaste_daemon_image_item_finalize (GObject* obj);
static void _vala_gpaste_daemon_image_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_daemon_image_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType gpaste_daemon_item_kind_get_type (void) {
	static volatile gsize gpaste_daemon_item_kind_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_item_kind_type_id__volatile)) {
		static const GEnumValue values[] = {{GPASTE_DAEMON_ITEM_KIND_TEXT, "GPASTE_DAEMON_ITEM_KIND_TEXT", "text"}, {GPASTE_DAEMON_ITEM_KIND_IMAGE, "GPASTE_DAEMON_ITEM_KIND_IMAGE", "image"}, {0, NULL, NULL}};
		GType gpaste_daemon_item_kind_type_id;
		gpaste_daemon_item_kind_type_id = g_enum_register_static ("GPasteDaemonItemKind", values);
		g_once_init_leave (&gpaste_daemon_item_kind_type_id__volatile, gpaste_daemon_item_kind_type_id);
	}
	return gpaste_daemon_item_kind_type_id__volatile;
}


static gboolean gpaste_daemon_item_real_has_value (GPasteDaemonItem* self) {
	g_critical ("Type `%s' does not implement abstract method `gpaste_daemon_item_has_value'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean gpaste_daemon_item_has_value (GPasteDaemonItem* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GPASTE_DAEMON_ITEM_GET_CLASS (self)->has_value (self);
}


static gchar* gpaste_daemon_item_real_get_display_str (GPasteDaemonItem* self) {
	g_critical ("Type `%s' does not implement abstract method `gpaste_daemon_item_get_display_str'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* gpaste_daemon_item_get_display_str (GPasteDaemonItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GPASTE_DAEMON_ITEM_GET_CLASS (self)->get_display_str (self);
}


static gchar* gpaste_daemon_item_real_get_kind (GPasteDaemonItem* self) {
	g_critical ("Type `%s' does not implement abstract method `gpaste_daemon_item_get_kind'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* gpaste_daemon_item_get_kind (GPasteDaemonItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GPASTE_DAEMON_ITEM_GET_CLASS (self)->get_kind (self);
}


static gboolean gpaste_daemon_item_real_equals (GPasteDaemonItem* self, GPasteDaemonItem* i) {
	g_critical ("Type `%s' does not implement abstract method `gpaste_daemon_item_equals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean gpaste_daemon_item_equals (GPasteDaemonItem* self, GPasteDaemonItem* i) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GPASTE_DAEMON_ITEM_GET_CLASS (self)->equals (self, i);
}


GPasteDaemonItem* gpaste_daemon_item_construct (GType object_type) {
	GPasteDaemonItem * self = NULL;
	self = (GPasteDaemonItem*) g_object_new (object_type, NULL);
	return self;
}


const gchar* gpaste_daemon_item_get_str (GPasteDaemonItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_str;
	result = _tmp0_;
	return result;
}


void gpaste_daemon_item_set_str (GPasteDaemonItem* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_str);
	self->priv->_str = _tmp1_;
	g_object_notify ((GObject *) self, "str");
}


static void gpaste_daemon_item_class_init (GPasteDaemonItemClass * klass) {
	gpaste_daemon_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteDaemonItemPrivate));
	GPASTE_DAEMON_ITEM_CLASS (klass)->has_value = gpaste_daemon_item_real_has_value;
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_display_str = gpaste_daemon_item_real_get_display_str;
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_kind = gpaste_daemon_item_real_get_kind;
	GPASTE_DAEMON_ITEM_CLASS (klass)->equals = gpaste_daemon_item_real_equals;
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_daemon_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_daemon_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_daemon_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_ITEM_STR, g_param_spec_string ("str", "str", "str", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_daemon_item_instance_init (GPasteDaemonItem * self) {
	self->priv = GPASTE_DAEMON_ITEM_GET_PRIVATE (self);
}


static void gpaste_daemon_item_finalize (GObject* obj) {
	GPasteDaemonItem * self;
	self = GPASTE_DAEMON_ITEM (obj);
	_g_free0 (self->priv->_str);
	G_OBJECT_CLASS (gpaste_daemon_item_parent_class)->finalize (obj);
}


GType gpaste_daemon_item_get_type (void) {
	static volatile gsize gpaste_daemon_item_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonItem), 0, (GInstanceInitFunc) gpaste_daemon_item_instance_init, NULL };
		GType gpaste_daemon_item_type_id;
		gpaste_daemon_item_type_id = g_type_register_static (G_TYPE_OBJECT, "GPasteDaemonItem", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&gpaste_daemon_item_type_id__volatile, gpaste_daemon_item_type_id);
	}
	return gpaste_daemon_item_type_id__volatile;
}


static void _vala_gpaste_daemon_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteDaemonItem * self;
	self = GPASTE_DAEMON_ITEM (object);
	switch (property_id) {
		case GPASTE_DAEMON_ITEM_STR:
		g_value_set_string (value, gpaste_daemon_item_get_str (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_daemon_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteDaemonItem * self;
	self = GPASTE_DAEMON_ITEM (object);
	switch (property_id) {
		case GPASTE_DAEMON_ITEM_STR:
		gpaste_daemon_item_set_str (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GPasteDaemonTextItem* gpaste_daemon_text_item_construct (GType object_type, const gchar* str) {
	GPasteDaemonTextItem * self = NULL;
	const gchar* _tmp0_;
	self = (GPasteDaemonTextItem*) gpaste_daemon_item_construct (object_type);
	_tmp0_ = str;
	gpaste_daemon_item_set_str ((GPasteDaemonItem*) self, _tmp0_);
	return self;
}


GPasteDaemonTextItem* gpaste_daemon_text_item_new (const gchar* str) {
	return gpaste_daemon_text_item_construct (GPASTE_DAEMON_TYPE_TEXT_ITEM, str);
}


static gchar* gpaste_daemon_text_item_real_get_display_str (GPasteDaemonItem* base) {
	GPasteDaemonTextItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	self = (GPasteDaemonTextItem*) base;
	_tmp0_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static gboolean gpaste_daemon_text_item_real_has_value (GPasteDaemonItem* base) {
	GPasteDaemonTextItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp7_;
	self = (GPasteDaemonTextItem*) base;
	_tmp1_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		_tmp3_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = string_strip (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "") != 0;
		_g_free0 (_tmp6_);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp7_ = _tmp0_;
	result = _tmp7_;
	return result;
}


static gchar* gpaste_daemon_text_item_real_get_kind (GPasteDaemonItem* base) {
	GPasteDaemonTextItem * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = (GPasteDaemonTextItem*) base;
	_tmp0_ = g_strdup ("Text");
	result = _tmp0_;
	return result;
}


static gboolean gpaste_daemon_text_item_real_equals (GPasteDaemonItem* base, GPasteDaemonItem* i) {
	GPasteDaemonTextItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GPasteDaemonItem* _tmp1_;
	gboolean _tmp7_;
	self = (GPasteDaemonTextItem*) base;
	g_return_val_if_fail (i != NULL, FALSE);
	_tmp1_ = i;
	if (GPASTE_DAEMON_IS_TEXT_ITEM (_tmp1_)) {
		GPasteDaemonItem* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp2_ = i;
		_tmp3_ = gpaste_daemon_item_get_str (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp7_ = _tmp0_;
	result = _tmp7_;
	return result;
}


static void gpaste_daemon_text_item_class_init (GPasteDaemonTextItemClass * klass) {
	gpaste_daemon_text_item_parent_class = g_type_class_peek_parent (klass);
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_display_str = gpaste_daemon_text_item_real_get_display_str;
	GPASTE_DAEMON_ITEM_CLASS (klass)->has_value = gpaste_daemon_text_item_real_has_value;
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_kind = gpaste_daemon_text_item_real_get_kind;
	GPASTE_DAEMON_ITEM_CLASS (klass)->equals = gpaste_daemon_text_item_real_equals;
}


static void gpaste_daemon_text_item_instance_init (GPasteDaemonTextItem * self) {
}


GType gpaste_daemon_text_item_get_type (void) {
	static volatile gsize gpaste_daemon_text_item_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_text_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonTextItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_text_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonTextItem), 0, (GInstanceInitFunc) gpaste_daemon_text_item_instance_init, NULL };
		GType gpaste_daemon_text_item_type_id;
		gpaste_daemon_text_item_type_id = g_type_register_static (GPASTE_DAEMON_TYPE_ITEM, "GPasteDaemonTextItem", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_daemon_text_item_type_id__volatile, gpaste_daemon_text_item_type_id);
	}
	return gpaste_daemon_text_item_type_id__volatile;
}


GPasteDaemonImageItem* gpaste_daemon_image_item_construct (GType object_type, GdkPixbuf* img) {
	GPasteDaemonImageItem * self = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	self = (GPasteDaemonImageItem*) gpaste_daemon_item_construct (object_type);
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	gpaste_daemon_image_item_set_date (self, _tmp1_);
	_g_date_time_unref0 (_tmp1_);
	_tmp2_ = img;
	gpaste_daemon_image_item_set_img (self, _tmp2_);
	_tmp3_ = img;
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp4_ = _ ("[Image no longer exists]");
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->display_str);
		self->priv->display_str = _tmp5_;
	} else {
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* images_dir;
		const gchar* _tmp8_;
		GFile* _tmp9_ = NULL;
		GFile* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_;
		GdkPixbuf* _tmp14_;
		guint8* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_;
		_tmp6_ = g_get_user_data_dir ();
		_tmp7_ = g_build_filename (_tmp6_, "gpaste", "images", NULL);
		images_dir = _tmp7_;
		_tmp8_ = images_dir;
		_tmp9_ = g_file_new_for_path (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_file_query_exists (_tmp10_, NULL);
		_tmp12_ = !_tmp11_;
		_g_object_unref0 (_tmp10_);
		if (_tmp12_) {
			const gchar* _tmp13_;
			_tmp13_ = images_dir;
			mkdir (_tmp13_, (mode_t) 0700);
		}
		_tmp14_ = img;
		_tmp15_ = gdk_pixbuf_get_pixels (_tmp14_);
		_tmp16_ = g_compute_checksum_for_data (G_CHECKSUM_SHA256, (guchar*) _tmp15_, -1);
		_tmp17_ = _tmp16_;
		gpaste_daemon_image_item_set_checksum (self, _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = images_dir;
		_tmp19_ = self->priv->_checksum;
		_tmp20_ = g_strconcat (_tmp19_, ".png", NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_build_filename (_tmp18_, _tmp21_, NULL);
		_tmp23_ = _tmp22_;
		gpaste_daemon_item_set_str ((GPasteDaemonItem*) self, _tmp23_);
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		{
			GdkPixbuf* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_ = NULL;
			GdkPixbuf* _tmp28_;
			gint _tmp29_ = 0;
			GdkPixbuf* _tmp30_;
			gint _tmp31_ = 0;
			GDateTime* _tmp32_;
			const gchar* _tmp33_ = NULL;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_;
			gchar* _tmp36_ = NULL;
			_tmp24_ = img;
			_tmp25_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
			_tmp26_ = _tmp25_;
			gdk_pixbuf_save (_tmp24_, _tmp26_, "png", &_inner_error_, NULL);
			if (_inner_error_ != NULL) {
				goto __catch6_g_error;
			}
			_tmp27_ = _ ("[Image, %d x %d (%s)]");
			_tmp28_ = self->priv->_img;
			_tmp29_ = gdk_pixbuf_get_width (_tmp28_);
			_tmp30_ = self->priv->_img;
			_tmp31_ = gdk_pixbuf_get_height (_tmp30_);
			_tmp32_ = self->priv->_date;
			_tmp33_ = _ ("%m/%d/%y %T");
			_tmp34_ = g_date_time_format (_tmp32_, _tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_strdup_printf (_tmp27_, _tmp29_, _tmp31_, _tmp35_);
			_g_free0 (self->priv->display_str);
			self->priv->display_str = _tmp36_;
			_g_free0 (_tmp35_);
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp37_ = NULL;
			gchar* _tmp38_;
			FILE* _tmp39_;
			const gchar* _tmp40_ = NULL;
			GError* _tmp41_;
			const gchar* _tmp42_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp37_ = _ ("[Image no longer exists]");
			_tmp38_ = g_strdup (_tmp37_);
			_g_free0 (self->priv->display_str);
			self->priv->display_str = _tmp38_;
			_tmp39_ = stderr;
			_tmp40_ = _ ("Error while saving pixbuf: %s\n");
			_tmp41_ = e;
			_tmp42_ = _tmp41_->message;
			fprintf (_tmp39_, _tmp40_, _tmp42_);
			_g_error_free0 (e);
		}
		__finally6:
		if (_inner_error_ != NULL) {
			_g_free0 (images_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (images_dir);
	}
	return self;
}


GPasteDaemonImageItem* gpaste_daemon_image_item_new (GdkPixbuf* img) {
	return gpaste_daemon_image_item_construct (GPASTE_DAEMON_TYPE_IMAGE_ITEM, img);
}


GPasteDaemonImageItem* gpaste_daemon_image_item_construct_load (GType object_type, const gchar* path, GDateTime* date) {
	GPasteDaemonImageItem * self = NULL;
	GDateTime* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (date != NULL, NULL);
	self = (GPasteDaemonImageItem*) gpaste_daemon_item_construct (object_type);
	_tmp0_ = date;
	gpaste_daemon_image_item_set_date (self, _tmp0_);
	_tmp1_ = path;
	gpaste_daemon_item_set_str ((GPasteDaemonItem*) self, _tmp1_);
	{
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
		const gchar* _tmp7_ = NULL;
		GdkPixbuf* _tmp8_;
		gint _tmp9_ = 0;
		GdkPixbuf* _tmp10_;
		gint _tmp11_ = 0;
		GDateTime* _tmp12_;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		_tmp2_ = gpaste_daemon_item_get_str ((GPasteDaemonItem*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = gdk_pixbuf_new_from_file (_tmp3_, &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			goto __catch7_g_error;
		}
		_tmp6_ = _tmp5_;
		gpaste_daemon_image_item_set_img (self, _tmp6_);
		_g_object_unref0 (_tmp6_);
		_tmp7_ = _ ("[Image, %d x %d (%s)]");
		_tmp8_ = self->priv->_img;
		_tmp9_ = gdk_pixbuf_get_width (_tmp8_);
		_tmp10_ = self->priv->_img;
		_tmp11_ = gdk_pixbuf_get_height (_tmp10_);
		_tmp12_ = self->priv->_date;
		_tmp13_ = _ ("%m/%d/%y %T");
		_tmp14_ = g_date_time_format (_tmp12_, _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strdup_printf (_tmp7_, _tmp9_, _tmp11_, _tmp15_);
		_g_free0 (self->priv->display_str);
		self->priv->display_str = _tmp16_;
		_g_free0 (_tmp15_);
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		FILE* _tmp19_;
		const gchar* _tmp20_ = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = _ ("[Image no longer exists]");
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (self->priv->display_str);
		self->priv->display_str = _tmp18_;
		_tmp19_ = stderr;
		_tmp20_ = _ ("Error while loading pixbuf: %s\n");
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		fprintf (_tmp19_, _tmp20_, _tmp22_);
		_g_error_free0 (e);
	}
	__finally7:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


GPasteDaemonImageItem* gpaste_daemon_image_item_new_load (const gchar* path, GDateTime* date) {
	return gpaste_daemon_image_item_construct_load (GPASTE_DAEMON_TYPE_IMAGE_ITEM, path, date);
}


static gchar* gpaste_daemon_image_item_real_get_display_str (GPasteDaemonItem* base) {
	GPasteDaemonImageItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	self = (GPasteDaemonImageItem*) base;
	_tmp0_ = self->priv->display_str;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


static gboolean gpaste_daemon_image_item_real_has_value (GPasteDaemonItem* base) {
	GPasteDaemonImageItem * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
	self = (GPasteDaemonImageItem*) base;
	_tmp0_ = self->priv->_img;
	result = _tmp0_ != NULL;
	return result;
}


static gchar* gpaste_daemon_image_item_real_get_kind (GPasteDaemonItem* base) {
	GPasteDaemonImageItem * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = (GPasteDaemonImageItem*) base;
	_tmp0_ = g_strdup ("Image");
	result = _tmp0_;
	return result;
}


static gboolean gpaste_daemon_image_item_real_equals (GPasteDaemonItem* base, GPasteDaemonItem* i) {
	GPasteDaemonImageItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GPasteDaemonItem* _tmp1_;
	gboolean _tmp5_;
	self = (GPasteDaemonImageItem*) base;
	g_return_val_if_fail (i != NULL, FALSE);
	_tmp1_ = i;
	if (GPASTE_DAEMON_IS_IMAGE_ITEM (_tmp1_)) {
		GPasteDaemonItem* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = i;
		_tmp3_ = (GPASTE_DAEMON_IS_IMAGE_ITEM (_tmp2_) ? ((GPasteDaemonImageItem*) _tmp2_) : NULL)->priv->_checksum;
		_tmp4_ = self->priv->_checksum;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = _tmp0_;
	result = _tmp5_;
	return result;
}


GDateTime* gpaste_daemon_image_item_get_date (GPasteDaemonImageItem* self) {
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}


static gpointer _g_date_time_ref0 (gpointer self) {
	return self ? g_date_time_ref (self) : NULL;
}


static void gpaste_daemon_image_item_set_date (GPasteDaemonImageItem* self, GDateTime* value) {
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
	_g_date_time_unref0 (self->priv->_date);
	self->priv->_date = _tmp1_;
	g_object_notify ((GObject *) self, "date");
}


const gchar* gpaste_daemon_image_item_get_checksum (GPasteDaemonImageItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_checksum;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_image_item_set_checksum (GPasteDaemonImageItem* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_checksum);
	self->priv->_checksum = _tmp1_;
	g_object_notify ((GObject *) self, "checksum");
}


GdkPixbuf* gpaste_daemon_image_item_get_img (GPasteDaemonImageItem* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_img;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gpaste_daemon_image_item_set_img (GPasteDaemonImageItem* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_img);
	self->priv->_img = _tmp1_;
	g_object_notify ((GObject *) self, "img");
}


static void gpaste_daemon_image_item_class_init (GPasteDaemonImageItemClass * klass) {
	gpaste_daemon_image_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteDaemonImageItemPrivate));
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_display_str = gpaste_daemon_image_item_real_get_display_str;
	GPASTE_DAEMON_ITEM_CLASS (klass)->has_value = gpaste_daemon_image_item_real_has_value;
	GPASTE_DAEMON_ITEM_CLASS (klass)->get_kind = gpaste_daemon_image_item_real_get_kind;
	GPASTE_DAEMON_ITEM_CLASS (klass)->equals = gpaste_daemon_image_item_real_equals;
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_daemon_image_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_daemon_image_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_daemon_image_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_IMAGE_ITEM_DATE, g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_IMAGE_ITEM_CHECKSUM, g_param_spec_string ("checksum", "checksum", "checksum", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_IMAGE_ITEM_IMG, g_param_spec_object ("img", "img", "img", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gpaste_daemon_image_item_instance_init (GPasteDaemonImageItem * self) {
	self->priv = GPASTE_DAEMON_IMAGE_ITEM_GET_PRIVATE (self);
}


static void gpaste_daemon_image_item_finalize (GObject* obj) {
	GPasteDaemonImageItem * self;
	self = GPASTE_DAEMON_IMAGE_ITEM (obj);
	_g_free0 (self->priv->display_str);
	_g_date_time_unref0 (self->priv->_date);
	_g_free0 (self->priv->_checksum);
	_g_object_unref0 (self->priv->_img);
	G_OBJECT_CLASS (gpaste_daemon_image_item_parent_class)->finalize (obj);
}


GType gpaste_daemon_image_item_get_type (void) {
	static volatile gsize gpaste_daemon_image_item_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_image_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonImageItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_image_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonImageItem), 0, (GInstanceInitFunc) gpaste_daemon_image_item_instance_init, NULL };
		GType gpaste_daemon_image_item_type_id;
		gpaste_daemon_image_item_type_id = g_type_register_static (GPASTE_DAEMON_TYPE_ITEM, "GPasteDaemonImageItem", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_daemon_image_item_type_id__volatile, gpaste_daemon_image_item_type_id);
	}
	return gpaste_daemon_image_item_type_id__volatile;
}


static void _vala_gpaste_daemon_image_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteDaemonImageItem * self;
	self = GPASTE_DAEMON_IMAGE_ITEM (object);
	switch (property_id) {
		case GPASTE_DAEMON_IMAGE_ITEM_DATE:
		g_value_set_boxed (value, gpaste_daemon_image_item_get_date (self));
		break;
		case GPASTE_DAEMON_IMAGE_ITEM_CHECKSUM:
		g_value_set_string (value, gpaste_daemon_image_item_get_checksum (self));
		break;
		case GPASTE_DAEMON_IMAGE_ITEM_IMG:
		g_value_set_object (value, gpaste_daemon_image_item_get_img (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_daemon_image_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteDaemonImageItem * self;
	self = GPASTE_DAEMON_IMAGE_ITEM (object);
	switch (property_id) {
		case GPASTE_DAEMON_IMAGE_ITEM_DATE:
		gpaste_daemon_image_item_set_date (self, g_value_get_boxed (value));
		break;
		case GPASTE_DAEMON_IMAGE_ITEM_CHECKSUM:
		gpaste_daemon_image_item_set_checksum (self, g_value_get_string (value));
		break;
		case GPASTE_DAEMON_IMAGE_ITEM_IMG:
		gpaste_daemon_image_item_set_img (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



